# coding=utf-8
# *** WARNING: this file was generated by the Pulumi SDK Generator. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union
from .. import _utilities, _tables
from . import outputs
from ._enums import *
from ._inputs import *

__all__ = ['NetworkGroup']


class NetworkGroup(pulumi.CustomResource):
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 conditional_membership: Optional[pulumi.Input[str]] = None,
                 description: Optional[pulumi.Input[str]] = None,
                 display_name: Optional[pulumi.Input[str]] = None,
                 group_members: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['GroupMembersItemArgs']]]]] = None,
                 member_type: Optional[pulumi.Input[Union[str, 'MemberType']]] = None,
                 network_group_name: Optional[pulumi.Input[str]] = None,
                 network_manager_name: Optional[pulumi.Input[str]] = None,
                 resource_group_name: Optional[pulumi.Input[str]] = None,
                 __props__=None,
                 __name__=None,
                 __opts__=None):
        """
        The network group resource
        API Version: 2021-02-01-preview.

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] conditional_membership: Network group conditional filter.
        :param pulumi.Input[str] description: A description of the network group.
        :param pulumi.Input[str] display_name: A friendly name for the network group.
        :param pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['GroupMembersItemArgs']]]] group_members: Group members of network group.
        :param pulumi.Input[Union[str, 'MemberType']] member_type: Group member type.
        :param pulumi.Input[str] network_group_name: The name of the network group to get.
        :param pulumi.Input[str] network_manager_name: The name of the network manager.
        :param pulumi.Input[str] resource_group_name: The name of the resource group.
        """
        if __name__ is not None:
            warnings.warn("explicit use of __name__ is deprecated", DeprecationWarning)
            resource_name = __name__
        if __opts__ is not None:
            warnings.warn("explicit use of __opts__ is deprecated, use 'opts' instead", DeprecationWarning)
            opts = __opts__
        if opts is None:
            opts = pulumi.ResourceOptions()
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.version is None:
            opts.version = _utilities.get_version()
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = dict()

            __props__['conditional_membership'] = conditional_membership
            __props__['description'] = description
            __props__['display_name'] = display_name
            __props__['group_members'] = group_members
            __props__['member_type'] = member_type
            __props__['network_group_name'] = network_group_name
            if network_manager_name is None and not opts.urn:
                raise TypeError("Missing required property 'network_manager_name'")
            __props__['network_manager_name'] = network_manager_name
            if resource_group_name is None and not opts.urn:
                raise TypeError("Missing required property 'resource_group_name'")
            __props__['resource_group_name'] = resource_group_name
            __props__['etag'] = None
            __props__['name'] = None
            __props__['provisioning_state'] = None
            __props__['system_data'] = None
            __props__['type'] = None
        alias_opts = pulumi.ResourceOptions(aliases=[pulumi.Alias(type_="azure-nextgen:network:NetworkGroup"), pulumi.Alias(type_="azure-native:network/v20210201preview:NetworkGroup"), pulumi.Alias(type_="azure-nextgen:network/v20210201preview:NetworkGroup")])
        opts = pulumi.ResourceOptions.merge(opts, alias_opts)
        super(NetworkGroup, __self__).__init__(
            'azure-native:network:NetworkGroup',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None) -> 'NetworkGroup':
        """
        Get an existing NetworkGroup resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = dict()

        __props__["conditional_membership"] = None
        __props__["description"] = None
        __props__["display_name"] = None
        __props__["etag"] = None
        __props__["group_members"] = None
        __props__["member_type"] = None
        __props__["name"] = None
        __props__["provisioning_state"] = None
        __props__["system_data"] = None
        __props__["type"] = None
        return NetworkGroup(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="conditionalMembership")
    def conditional_membership(self) -> pulumi.Output[Optional[str]]:
        """
        Network group conditional filter.
        """
        return pulumi.get(self, "conditional_membership")

    @property
    @pulumi.getter
    def description(self) -> pulumi.Output[Optional[str]]:
        """
        A description of the network group.
        """
        return pulumi.get(self, "description")

    @property
    @pulumi.getter(name="displayName")
    def display_name(self) -> pulumi.Output[Optional[str]]:
        """
        A friendly name for the network group.
        """
        return pulumi.get(self, "display_name")

    @property
    @pulumi.getter
    def etag(self) -> pulumi.Output[str]:
        """
        A unique read-only string that changes whenever the resource is updated.
        """
        return pulumi.get(self, "etag")

    @property
    @pulumi.getter(name="groupMembers")
    def group_members(self) -> pulumi.Output[Optional[Sequence['outputs.GroupMembersItemResponse']]]:
        """
        Group members of network group.
        """
        return pulumi.get(self, "group_members")

    @property
    @pulumi.getter(name="memberType")
    def member_type(self) -> pulumi.Output[Optional[str]]:
        """
        Group member type.
        """
        return pulumi.get(self, "member_type")

    @property
    @pulumi.getter
    def name(self) -> pulumi.Output[str]:
        """
        Resource name.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter(name="provisioningState")
    def provisioning_state(self) -> pulumi.Output[str]:
        """
        The provisioning state of the scope assignment resource.
        """
        return pulumi.get(self, "provisioning_state")

    @property
    @pulumi.getter(name="systemData")
    def system_data(self) -> pulumi.Output['outputs.SystemDataResponse']:
        """
        The system metadata related to this resource.
        """
        return pulumi.get(self, "system_data")

    @property
    @pulumi.getter
    def type(self) -> pulumi.Output[str]:
        """
        Resource type.
        """
        return pulumi.get(self, "type")

    def translate_output_property(self, prop):
        return _tables.CAMEL_TO_SNAKE_CASE_TABLE.get(prop) or prop

    def translate_input_property(self, prop):
        return _tables.SNAKE_TO_CAMEL_CASE_TABLE.get(prop) or prop

